Index: NEMO/branches/2019/dev_r12072_TOP-01_ENHANCE-11_CEthe/cfgs/SHARED/namelist_ref
===================================================================
--- NEMO/branches/2019/dev_r12072_TOP-01_ENHANCE-11_CEthe/cfgs/SHARED/namelist_ref	(revision 12112)
+++ NEMO/branches/2019/dev_r12072_TOP-01_ENHANCE-11_CEthe/cfgs/SHARED/namelist_ref	(revision 12113)
@@ -392,4 +392,8 @@
       ln_sssr_bnd =  .true.   !  flag to bound erp term (associated with nn_sssr=2)
       rn_sssr_bnd =   4.e0    !  ABS(Max/Min) value of the damping erp term [mm/day]
+      nn_sssr_ice =   1       ! control of sea surface restoring under sea-ice
+                              ! 0 = no restoration under ice : * (1-icefrac)
+                              ! 1 = restoration everywhere 
+                              ! >1 = enhanced restoration under ice : 1+(nn_icedmp-1)*icefrac
 
    cn_dir      = './'      !  root directory for the SST/SSS data location
Index: NEMO/branches/2019/dev_r12072_TOP-01_ENHANCE-11_CEthe/src/OCE/SBC/sbcssr.F90
===================================================================
--- NEMO/branches/2019/dev_r12072_TOP-01_ENHANCE-11_CEthe/src/OCE/SBC/sbcssr.F90	(revision 12112)
+++ NEMO/branches/2019/dev_r12072_TOP-01_ENHANCE-11_CEthe/src/OCE/SBC/sbcssr.F90	(revision 12113)
@@ -43,5 +43,5 @@
    LOGICAL         ::   ln_sssr_bnd     ! flag to bound erp term 
    REAL(wp)        ::   rn_sssr_bnd     ! ABS(Max./Min.) value of erp term [mm/day]
-   INTEGER         ::   nn_icedmp       ! Control of restoring under ice
+   INTEGER         ::   nn_sssr_ice     ! Control of restoring under ice
 
    REAL(wp) , ALLOCATABLE, DIMENSION(:) ::   buffer   ! Temporary buffer for exchange
@@ -102,12 +102,12 @@
             ENDIF
             !
-            IF( nn_sssr /= 0 .AND. nn_icedmp /= 1 ) THEN
-              ! use fraction of ice ( fr_i ) to adjust relaxation under ice if nn_icedmp .ne. 1
-              ! n.b. coefice is initialised and fixed to 1._wp if nn_icedmp = 1
+            IF( nn_sssr /= 0 .AND. nn_sssr_ice /= 1 ) THEN
+              ! use fraction of ice ( fr_i ) to adjust relaxation under ice if nn_sssr_ice .ne. 1
+              ! n.b. coefice is initialised and fixed to 1._wp if nn_sssr_ice = 1
                DO jj = 1, jpj
                   DO ji = 1, jpi
-                     SELECT CASE ( nn_icedmp )
+                     SELECT CASE ( nn_sssr_ice )
                        CASE ( 0 )    ;  coefice(ji,jj) = 1._wp - fr_i(ji,jj)              ! no/reduced damping under ice
-                       CASE  DEFAULT ;  coefice(ji,jj) = 1._wp +(nn_icedmp-1)*fr_i(ji,jj) ! reinforced damping (x nn_icedmp) under ice )
+                       CASE  DEFAULT ;  coefice(ji,jj) = 1._wp + ( nn_sssr_ice - 1 ) * fr_i(ji,jj) ! reinforced damping (x nn_sssr_ice) under ice )
                      END SELECT
                   END DO
@@ -170,5 +170,5 @@
       TYPE(FLD_N) ::   sn_sst, sn_sss        ! informations about the fields to be read
       NAMELIST/namsbc_ssr/ cn_dir, nn_sstr, nn_sssr, rn_dqdt, rn_deds, sn_sst, &
-              & sn_sss, ln_sssr_bnd, rn_sssr_bnd, nn_icedmp
+              & sn_sss, ln_sssr_bnd, rn_sssr_bnd, nn_sssr_ice
       INTEGER     ::  ios
       !!----------------------------------------------------------------------
@@ -198,5 +198,5 @@
          WRITE(numout,*) '         flag to bound erp term                 ln_sssr_bnd = ', ln_sssr_bnd
          WRITE(numout,*) '         ABS(Max./Min.) erp threshold           rn_sssr_bnd = ', rn_sssr_bnd, ' mm/day'
-         WRITE(numout,*) '      Cntrl of surface restoration under ice nn_icedmp      = ', nn_icedmp
+         WRITE(numout,*) '      Cntrl of surface restoration under ice nn_sssr_ice    = ', nn_sssr_ice
          WRITE(numout,*) '          ( 0 = no restoration under ice)'
          WRITE(numout,*) '          ( 1 = restoration everywhere  )'
@@ -232,5 +232,5 @@
       ENDIF
       !
-      coefice(:,:) = 1._wp         !  Initialise coefice to 1._wp ; will not need to be changed if nn_icedmp=1
+      coefice(:,:) = 1._wp         !  Initialise coefice to 1._wp ; will not need to be changed if nn_sssr_ice=1
       !                            !* Initialize qrp and erp if no restoring 
       IF( nn_sstr /= 1                   )   qrp(:,:) = 0._wp