Index: NEMO/branches/2019/dev_r11643_ENHANCE-11_CEthe_Shaconemo_diags/src/OCE/DIA/diaar5.F90
===================================================================
--- NEMO/branches/2019/dev_r11643_ENHANCE-11_CEthe_Shaconemo_diags/src/OCE/DIA/diaar5.F90	(revision 12114)
+++ NEMO/branches/2019/dev_r11643_ENHANCE-11_CEthe_Shaconemo_diags/src/OCE/DIA/diaar5.F90	(revision 12124)
@@ -30,6 +30,6 @@
    PUBLIC   dia_ar5_hst    ! heat/salt transport
 
-   REAL(wp)                         ::   vol0         ! ocean volume (interior domain)
-   REAL(wp)                         ::   area_tot     ! total ocean surface (interior domain)
+   REAL(wp) ::   vol0         ! ocean volume (interior domain)
+   REAL(wp) ::   area_tot     ! total ocean surface (interior domain)
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:  ) ::   area         ! cell surface (interior domain)
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:  ) ::   thick0       ! ocean thickness (interior domain)
@@ -327,11 +327,11 @@
       !! Called from all advection and/or diffusion routines
       !!----------------------------------------------------------------------
-      INTEGER                         , INTENT(in )  :: ktra  ! tracer index
-      CHARACTER(len=3)                , INTENT(in)   :: cptr  ! transport type  'adv'/'ldf'
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in)   :: pua   ! 3D input array of advection/diffusion
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in)   :: pva   ! 3D input array of advection/diffusion
-      !
-      INTEGER    ::  ji, jj, jk
-      REAL(wp), DIMENSION(jpi,jpj)  :: z2d
+      INTEGER                         , INTENT(in) ::   ktra  ! tracer index
+      CHARACTER(len=3)                , INTENT(in) ::   cptr  ! transport type  'adv'/'ldf'
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in) ::   pua   ! 3D input array of advection/diffusion
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in) ::   pva   ! 3D input array of advection/diffusion
+      !
+      INTEGER ::  ji, jj, jk
+      REAL(wp), DIMENSION(jpi,jpj) ::   z2d
 
     
Index: NEMO/branches/2019/dev_r11643_ENHANCE-11_CEthe_Shaconemo_diags/src/OCE/DIA/diahth.F90
===================================================================
--- NEMO/branches/2019/dev_r11643_ENHANCE-11_CEthe_Shaconemo_diags/src/OCE/DIA/diahth.F90	(revision 12114)
+++ NEMO/branches/2019/dev_r11643_ENHANCE-11_CEthe_Shaconemo_diags/src/OCE/DIA/diahth.F90	(revision 12124)
@@ -303,10 +303,10 @@
    SUBROUTINE dia_hth_dep( ptem, pdept )
       !
-      REAL(wp), INTENT(in) :: ptem
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(out) :: pdept     
-      !
-      INTEGER  :: ji, jj, jk, iid
-      REAL(wp) :: zztmp, zzdep
-      INTEGER, DIMENSION(jpi,jpj) :: iktem
+      REAL(wp),                     INTENT(in)  ::   ptem
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(out) ::   pdept     
+      !
+      INTEGER  ::   ji, jj, jk, iid
+      REAL(wp) ::   zztmp, zzdep
+      INTEGER, DIMENSION(jpi,jpj) ::   iktem
       
       ! --------------------------------------- !
@@ -349,11 +349,11 @@
    SUBROUTINE dia_hth_htc( pdep, ptn, phtc )
       !
-      REAL(wp), INTENT(in) :: pdep     ! depth over the heat content
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in) :: ptn   
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: phtc  
-      !
-      INTEGER  :: ji, jj, jk, ik
-      REAL(wp), DIMENSION(jpi,jpj) :: zthick
-      INTEGER , DIMENSION(jpi,jpj) :: ilevel
+      REAL(wp),                         INTENT(in)    ::   pdep     ! depth over the heat content
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in)    ::   ptn   
+      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(inout) ::   phtc  
+      !
+      INTEGER  ::   ji, jj, jk, ik
+      REAL(wp), DIMENSION(jpi,jpj) ::   zthick
+      INTEGER , DIMENSION(jpi,jpj) ::   ilevel
 
 
Index: NEMO/branches/2019/dev_r11643_ENHANCE-11_CEthe_Shaconemo_diags/src/OCE/IOM/iom.F90
===================================================================
--- NEMO/branches/2019/dev_r11643_ENHANCE-11_CEthe_Shaconemo_diags/src/OCE/IOM/iom.F90	(revision 12114)
+++ NEMO/branches/2019/dev_r11643_ENHANCE-11_CEthe_Shaconemo_diags/src/OCE/IOM/iom.F90	(revision 12124)
@@ -1730,5 +1730,5 @@
 
    SUBROUTINE iom_p4d( cdname, pfield4d )
-      CHARACTER(LEN=*)                , INTENT(in) ::   cdname
+      CHARACTER(LEN=*)                  , INTENT(in) ::   cdname
       REAL(wp),       DIMENSION(:,:,:,:), INTENT(in) ::   pfield4d
 #if defined key_iomput
Index: NEMO/branches/2019/dev_r11643_ENHANCE-11_CEthe_Shaconemo_diags/src/OCE/SBC/sbcblk.F90
===================================================================
--- NEMO/branches/2019/dev_r11643_ENHANCE-11_CEthe_Shaconemo_diags/src/OCE/SBC/sbcblk.F90	(revision 12114)
+++ NEMO/branches/2019/dev_r11643_ENHANCE-11_CEthe_Shaconemo_diags/src/OCE/SBC/sbcblk.F90	(revision 12124)
@@ -918,10 +918,10 @@
       IF( iom_use('evap_ao_cea') .OR. iom_use('hflx_evap_cea') ) THEN
          ztmp(:,:) = zevap(:,:) * ( 1._wp - at_i_b(:,:) ) 
-         IF( iom_use('evap_ao_cea'  ) )  CALL iom_put( 'evap_ao_cea'  , ztmp(:,:) * tmask(:,:,1) )   ! ice-free oce evap (cell average)
-         IF( iom_use('hflx_evap_cea') )  CALL iom_put( 'hflx_evap_cea', ztmp(:,:) * sst_m(:,:) * rcp * tmask(:,:,1) )   ! heat flux from evap (cell average)
+         CALL iom_put( 'evap_ao_cea'  , ztmp(:,:) * tmask(:,:,1) )   ! ice-free oce evap (cell average)
+         CALL iom_put( 'hflx_evap_cea', ztmp(:,:) * sst_m(:,:) * rcp * tmask(:,:,1) )   ! heat flux from evap (cell average)
       ENDIF
       IF( iom_use('hflx_rain_cea') ) THEN
          ztmp(:,:) = rcp * ( SUM( (ptsu-rt0) * a_i_b, dim=3 ) + sst_m(:,:) * ( 1._wp - at_i_b(:,:) ) )
-         IF( iom_use('hflx_rain_cea') )  CALL iom_put( 'hflx_rain_cea', ( tprecip(:,:) - sprecip(:,:) ) * ztmp(:,:) )   ! heat flux from rain (cell average)
+         CALL iom_put( 'hflx_rain_cea', ( tprecip(:,:) - sprecip(:,:) ) * ztmp(:,:) )   ! heat flux from rain (cell average)
       ENDIF
       IF( iom_use('hflx_snow_cea') .OR. iom_use('hflx_snow_ao_cea') .OR. iom_use('hflx_snow_ai_cea')  )  THEN
@@ -930,7 +930,7 @@
           ENDWHERE
           ztmp2(:,:) = sprecip(:,:) * ( ztmp(:,:) - rLfus ) 
-          IF( iom_use('hflx_snow_cea')    ) CALL iom_put('hflx_snow_cea'   , ztmp2(:,:) ) ! heat flux from snow (cell average)
-          IF( iom_use('hflx_snow_ao_cea') ) CALL iom_put('hflx_snow_ao_cea', ztmp2(:,:) * ( 1._wp - zsnw(:,:) ) ) ! heat flux from snow (over ocean)
-          IF( iom_use('hflx_snow_ai_cea') ) CALL iom_put('hflx_snow_ai_cea', ztmp2(:,:) *           zsnw(:,:)   ) ! heat flux from snow (over ice)
+          CALL iom_put('hflx_snow_cea'   , ztmp2(:,:) ) ! heat flux from snow (cell average)
+          CALL iom_put('hflx_snow_ao_cea', ztmp2(:,:) * ( 1._wp - zsnw(:,:) ) ) ! heat flux from snow (over ocean)
+          CALL iom_put('hflx_snow_ai_cea', ztmp2(:,:) *           zsnw(:,:)   ) ! heat flux from snow (over ice)
       ENDIF
       !